


#include <stdlib.mqh>

// ------------------------------------------------------------------------------------------ //
//                            E X T E R N A L   V A R I A B L E S                             //
// ------------------------------------------------------------------------------------------ //

extern   bool     EcnBroker     = true;
extern   bool     TradeInside   = false;    // Trading inside Trendlines  : Bouncing Trade
extern   bool     TradeOutside  = true;    // Trading outside Trendlines : Breaking Trade
extern   string   UpperLineName = "Upperline";
extern   string   LowerLineName = "Lowerline";
extern   double   LotSize       = 0.1;
extern   double   TakeProfit    = 50;
extern   double   StopLoss      = 30;
extern   double   Pipaway       = 3; 
extern   double   Piplimit      = 10;       
extern   int      Slippage      = 3;
extern   int      Magic         = 2121212;
extern   string   EAcomment     = "";
extern   bool     ScreenDisplay      = true;

// ------------------------------------------------------------------------------------------ //
//                            I N T E R N A L   V A R I A B L E S                             //
// ------------------------------------------------------------------------------------------ //

double   point = 0, pipMultiplier = 1;
string   strtmp, sig;
int      myBars;
double   upper, prevupper, lower, prevlower, openprice;

// ------------------------------------------------------------------------------------------ //
//                             I N I T I A L I S A T I O N                                    //
// ------------------------------------------------------------------------------------------ //

int init()
{
   if (Digits==3 || Digits==5) 
         pipMultiplier = 10;
   else  pipMultiplier = 1;               
         point = Point*pipMultiplier;
   sig="N/A";      
   Comment("");
   return(0);    
}

// ------------------------------------------------------------------------------------------ //
//                            D E - I N I T I A L I S A T I O N                               //
// ------------------------------------------------------------------------------------------ //

int deinit()
{
   Comment("");
   return(0);
}

// ------------------------------------------------------------------------------------------ //
//                                M A I N   P R O C E D U R E                                 //
// ------------------------------------------------------------------------------------------ //



int start()
{
   // Check for Trendline 
   // ============================================
   
   if (ObjectFind(UpperLineName)<0) upper = -1;
   else {
      upper = ObjectGetValueByShift(UpperLineName,1);
      prevupper = ObjectGetValueByShift(UpperLineName,2);
   }
   
   if (ObjectFind(LowerLineName)<0)   lower = -1;
   else {
      lower = ObjectGetValueByShift(LowerLineName,1);
      prevlower = ObjectGetValueByShift(LowerLineName,2);
   }
   
   if (isNewBar()) check_sig(); 
   
   // Trade Decision when both Trendlines are Ready
   // =============================================
   
   if (upper>0 && lower>0)
   {
      if (TradeOutside==True)
      {
         // Price is breaking/leaving UP Linexcutor1
         if ((sig=="Buy_Outside") && (Ask>=openprice) && (Ask<(openprice+Piplimit*point)))
         {
            Alert("Price Breaking UP !!!");
            if (OpenOrd(Magic)==0)   Buy(Magic,LotSize,TakeProfit,StopLoss);
            else
            if (OpenLast(Magic)==1)
            {  
               CloseOrders(Magic); Sleep(3000);
               Buy(Magic,LotSize,TakeProfit,StopLoss);
            }
         }

         // Price is breaking/leaving DOWN Linexcutor2
         if ((sig=="Sell_Outside") && (Bid<=openprice) && (Ask>(openprice-Piplimit*point)))
         {
            Alert("Price Breaking DOWN !!!");
            if (OpenOrd(Magic)==0)   Sell(Magic,LotSize,TakeProfit,StopLoss);
            else
            if (OpenLast(Magic)==0)
            {
               CloseOrders(Magic); Sleep(3000); 
               Sell(Magic,LotSize,TakeProfit,StopLoss);
            }
         }
      }
      
      if (TradeInside==True)
      {
         // Price is bouncing Linexcutor1
         if ((sig=="Sell_Inside") && (Bid<=openprice) && (Ask>(openprice-Piplimit*point)))
         {
            Alert("Price Bouncing UPPERline !!!");
            if (OpenOrd(Magic)==0)   Sell(Magic,LotSize,TakeProfit,StopLoss);
            else
            if (OpenLast(Magic)==0)
            {  
               CloseOrders(Magic); Sleep(3000); 
               Sell(Magic,LotSize,TakeProfit,StopLoss);
            }
         }

         // Price is bouncing Linexcutor2
         if ((sig=="Buy_Inside") && (Ask>=openprice) && (Ask<(openprice+Piplimit*point)))
         {
            Alert("Price Bouncing LOWERline !!!");
            if (OpenOrd(Magic)==0)   Buy(Magic,LotSize,TakeProfit,StopLoss);
            else
            if (OpenLast(Magic)==1)
            {  
               CloseOrders(Magic); Sleep(3000); 
               Buy(Magic,LotSize,TakeProfit,StopLoss);  
            }
         }       
      }
      }
    if (ScreenDisplay) checkcomment();             
    return(0);
   }
      
// ------------------------------------------------------------------------------------------ //
//                                 O R D E R S   S T A T U S                                  //
// ------------------------------------------------------------------------------------------ //

int OpenLast(int mgc)
{
   int   last=-1;
      
   for (int i = 0; i < OrdersTotal(); i++)
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if (OrderMagicNumber() == mgc && OrderSymbol()==Symbol() && OrderType()<=1)
          last = OrderType();
   }      
   return(last);
}

int OpenOrd(int mgc)
{
   int      ord=0;
   
   for (int i = 0; i < OrdersTotal(); i++)
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if (OrderMagicNumber() == mgc && OrderSymbol()==Symbol() && OrderType()<=1)
          ord++;
   }      
   return(ord);
}

// ------------------------------------------------------------------------------------------ //
//                                 C A L C U L A T E    P I P S                               //
// ------------------------------------------------------------------------------------------ //

int CalcPips(int mgc)
{
   int pips = 0;
   double p = 0;
   
   for (int i=0; i<OrdersTotal(); i++)
   {
        OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
        if  (OrderMagicNumber()==mgc && OrderSymbol()==Symbol())
        {
            if (OrderType()==OP_BUY)
            {
               p = (Ask - OrderOpenPrice())*pipMultiplier/point;
               pips = pips + NormalizeDouble(p,0);
            }
            if (OrderType()==OP_SELL)
            {
               p = (OrderOpenPrice() - Bid)*pipMultiplier/point;
               pips = pips + NormalizeDouble(p,0);
            }        
        }
   }   
   return(pips);
}

// ------------------------------------------------------------------------------------------ //
//                              C A L C U L A T E    P R O F I T                              //
// ------------------------------------------------------------------------------------------ //

double CalcProfit(int mgc)
{
   double profit = 0;
   for (int i=0; i<OrdersTotal(); i++)
   {
        OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
        if  (OrderMagicNumber()==mgc && OrderSymbol()==Symbol())
             profit = profit + OrderProfit() + OrderSwap();
   }   
   return(profit);
}

// ------------------------------------------------------------------------------------------ //
//                                  B U Y   F U N C T I O N                                   //
// ------------------------------------------------------------------------------------------ //

int Buy(int mgc, double lot,  double Tpft, double Slos)
{ 
    int     buyTicket = 0, err = 0;
    double  TP = 0,      SL = 0;
    
    if (Tpft>0)   TP = NormalizeDouble(Ask + (Tpft*point), Digits);
    if (Slos>0)   SL = NormalizeDouble(Ask - (Slos*point), Digits);

    if (IsTradeAllowed() == true)
    {       
       for(int c=0; c<5; c++)
       {
          RefreshRates();
          
          if (!EcnBroker) {
   		       OrderSend(Symbol(),OP_BUY,lot,Ask,Slippage*point,SL,TP,EAcomment, mgc,0,Blue);
   		       sig="BuyEntered";
   		       openprice=0;
   		    }		    
          else
             {
                    buyTicket = OrderSend(Symbol(),OP_BUY,lot,Ask,Slippage*point,0,0,EAcomment, mgc,0,Blue);
                    
                if (buyTicket >= 0)
                     sig="BuyEntered";
                     openprice=0;
                     OrderModify(buyTicket,OrderOpenPrice(),SL,TP,0,CLR_NONE);
                     if (buyTicket<0) Alert("OpenOrder failed: ", GetLastError());  
                          
                     Print("Errors opening BUY order");
                     Print(ErrorDescription(err),", error ",err);
                     if(err==4 || err==137 ||err==146 || err==136)   {Sleep(5000);continue;} 
                     else  break; //normal error                              // Busy errors
         }
       }
    } 	    
    return(buyTicket);      
}

// ------------------------------------------------------------------------------------------ //
//                                S E L L   F U N C T I O N                                   //
// ------------------------------------------------------------------------------------------ //

int Sell(int mgc, double lot, double Tpft, double Slos)
{        
    int     sellTicket = 0,err = 0;
    double  TP  = 0,       SL = 0;
    
    if (Tpft>0)   TP = NormalizeDouble(Bid - (Tpft*point), Digits);
    if (Slos>0)   SL = NormalizeDouble(Bid + (Slos*point), Digits);

    if (IsTradeAllowed() == true)
    { 
       for(int c=0; c<5; c++)
       { 
         RefreshRates();
         
         if (!EcnBroker) {
         
   		       OrderSend(Symbol(),OP_SELL,lot,Bid,Slippage*point,SL,TP,EAcomment,mgc,0,Red);
   		       sig="SellEntered";
   		       openprice=0;
   		    }		    		    
          else
                {
                   sellTicket = OrderSend(Symbol(),OP_SELL,lot,Bid,Slippage*point,0,0,EAcomment,mgc,0,Red);
                   
                		    		    
                  if (sellTicket >= 0)
                     sig="SellEntered";
                     openprice=0;
                     OrderModify(sellTicket,OrderOpenPrice(),SL,TP,0,CLR_NONE);
             		   if (sellTicket<0) Alert("OpenOrder failed: ", GetLastError());  
                          
                     Print("Errors opening SELL order");
                     Print(ErrorDescription(err),", error ",err);
                     if(err==4 || err==137 ||err==146 || err==136)   {Sleep(5000);continue;} 
                     else  break; //normal error                              // Busy errors
         }
       }
    } 	    
    return(sellTicket);      
}

// ------------------------------------------------------------------------------------------ //
//                                  C L O S E  O R D E R S                                    //
// ------------------------------------------------------------------------------------------ //

void CloseOrders(int mgc)
{
      int cnt,c,total=0,ticket=0,err=0;
      
      if (IsTradeAllowed() == true)
      { 
       total = OrdersTotal();
       for(cnt=total-1;cnt>=0;cnt--)
       {
          OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

          if(OrderMagicNumber()==mgc && OrderSymbol()==Symbol())
          {
             switch(OrderType())
             {
                case OP_BUY      :
                   for(c=0;c<5;c++)
                   {
                      RefreshRates();
                      OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),3,Yellow);
                      err = GetLastError();
                      if (err==0)   break;
                      else
                      {
                         Print("Errors Closing BUY order");
                         Print(ErrorDescription(err),", error ",err);
                         if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146)
                         { Sleep(5000); continue; }                            // Busy errors
                      }
                   }   
                   break;
               
                case OP_SELL     :
                   for(c=0;c<5;c++)
                   {
                      RefreshRates();
                      OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),3,Yellow);
                      err = GetLastError();
                      if (err==0) break;
                      else
                      {
                         Print("Errors Closing SELL order");
                         Print(ErrorDescription(err),", error ",err);
                         if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146)
                         { Sleep(5000); continue; }                            // Busy errors
                      }
                   }   
                   break;
             } // end of switch
          } // end of if
       } // end of for
      }       
      return(0);
}

bool isNewBar() {
//---- 
   bool res=false;
   if (myBars!=Bars) {
      myBars=Bars;
      res=true;
   }
//----    
   return(res);   
}              

void check_sig() {
//----
   if (TradeOutside==True) {
      if ((Close[1]>upper) && (Close[2]<=prevupper)) {
         sig="Buy_Outside";
         openprice=High[1]+Pipaway*point;
      }
      else if ((Close[1]<lower) && (Close[2]>=prevlower)) {
         sig="Sell_Outside";
         openprice=Low[1]-Pipaway*point;
      }
   }

   if (TradeInside==True) {   
      if ((Close[1]>=lower) && (Close[2]<prevlower)) {
         sig="Buy_Inside";
         openprice=High[1]+Pipaway*point;
      } 
      else if ((Close[1]<=upper) && (Close[2]>prevupper)) {
         sig="Sell_Inside";
         openprice=Low[1]-Pipaway*point;
      } 
   }       
}

void checkcomment() {
//----
   Comment("\n-----------------------------"+
           "\n-- "+"Current upper trend line value is:  "+DoubleToStr(upper,Digits)+ 
           "\n-- "+"Current lower trend line value is:  "+DoubleToStr(lower,Digits)+ 
           "\n-- "+"Current signal status is:  "+sig+ 
           "\n-- "+"Target open price for pending order is:  "+DoubleToStr(openprice,Digits)+ 
           //"\n-- "+"Current order profit in pips:  "+DoubleToStr(CalcPips(Magic),0)+
           //"\n-- "+"Current order profit in $$:  "+DoubleToStr(CalcProfit(Magic),2)+
           "\n-----------------------------");
}

// ------------------------------------------------------------------------------------------ //
//                        E N D   O F   E X P E R T   A D V I S O R                           //
// ------------------------------------------------------------------------------------------ //

